package main

import (
	"github.com/glebarez/sqlite"
	"gorm.io/gen"
	"gorm.io/gorm"

	"git.mstar.dev/mstar/mstar-webserver/storage/models"
)

func main() {
	g := gen.NewGenerator(gen.Config{
		OutPath: "./storage/generated",
		Mode:    gen.WithoutContext | gen.WithDefaultQuery | gen.WithQueryInterface, // generate mode
	})

	gormdb, _ := gorm.Open(sqlite.Open("./db.sqlite"), &gorm.Config{})
	g.UseDB(gormdb)

	// Generate basic type-safe DAO API for struct `model.User` following conventions
	g.ApplyBasic(models.Link{})

	// Generate Type Safe API with Dynamic SQL defined on Querier interface for `model.User` and `model.Company`
	g.ApplyInterface(func(models.ILink) {}, models.Link{})

	// Generate the code
	g.Execute()
}
